// 64-Detect
// by Hendricks266

#include "64switch.h"

int main(void)
{
    int returnval = 32;

            const wchar_t *PROCESSOR_ARCHITECTURE = wgetenv(L"PROCESSOR_ARCHITECTURE");
            const wchar_t *PROCESSOR_ARCHITEW6432 = wgetenv(L"PROCESSOR_ARCHITEW6432");
            if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"amd64") == 0) || (PROCESSOR_ARCHITEW6432 && wcscasecmp(PROCESSOR_ARCHITEW6432,L"amd64") == 0))
                returnval = 64;
            else if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"x86") == 0) && !PROCESSOR_ARCHITEW6432)
                returnval = 32;

	return returnval;
}
