// 64-Diagnose
// by Hendricks266

#include "64switch.h"

int main(void)
{
    static const wchar_t *suffix32 = L"32";
    static const wchar_t *suffix64 = L"64";
    int returnval = 32;

    const wchar_t *suffix = suffix32;

            const wchar_t *PROCESSOR_ARCHITECTURE = wgetenv(L"PROCESSOR_ARCHITECTURE");
            const wchar_t *PROCESSOR_ARCHITEW6432 = wgetenv(L"PROCESSOR_ARCHITEW6432");
            if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"amd64") == 0) || (PROCESSOR_ARCHITEW6432 && wcscasecmp(PROCESSOR_ARCHITEW6432,L"amd64") == 0))
            {
                suffix = suffix64;
                returnval = 64;
            }
            else if ((PROCESSOR_ARCHITECTURE && wcscasecmp(PROCESSOR_ARCHITECTURE,L"x86") == 0) && !PROCESSOR_ARCHITEW6432)
            {
                suffix = suffix32;
                returnval = 32;
            }

    wprintf(L"PROCESSOR_ARCHITECTURE: %s\nPROCESSOR_ARCHITEW6432: %s\nresult: %s\n", PROCESSOR_ARCHITECTURE, PROCESSOR_ARCHITEW6432, suffix);

	return returnval;
}
